local function myLog(num, base) return (math.log(num) / math.log(base or 10)); end
local function myRound(num, mul)
    if num and num >= 0 then return (math.floor((num/(mul))+0.5) * (mul));
    else return math.ceil(((num/(mul))-0.5) * (mul));
    end
end
local function myCeil(num, mul) return ( math.floor((tonumber(num)/(tonumber(mul) or 1))) * (tonumber(mul) or 1)); end
local function myFloor(num, mul) return ( math.ceil((tonumber(num)/(tonumber(mul) or 1))) * (tonumber(mul) or 1)); end
PocketGnome = {output={}, mfuncs = {pi = math.pi,cos = math.cos,acos = math.acos,sin = math.sin,asin = math.asin,tan = math.tan,atan = math.atan2,answer = 0,ln = math.log,log = myLog,floor = math.floor,ceil = math.ceil,round = myRound,sqrt = math.sqrt,deg = math.deg,rad = math.rad,e = math.exp(1),abs = math.abs}};
function PocketGnome.Crunch(text)
    if text:len() == 0 then text = PocketGnome.prevMath or "" end
    local str = text:gsub("%a[%w_]*", "PocketGnome.mfuncs.%0");
    local result,err;
    if str:match("=") then result,err = loadstring(str .. "; return ('OK')");
    else result,err = loadstring("return (" ..str .. ") ");end
    local ret, val = pcall(result);
    if ret == true and val ~= nil then
        if val ~= "OK" then
            PocketGnome.mfuncs.answer = val;
            if select(2,math.modf(math.abs(val))) > 0 then val = string.format("%.4f", val);else val = string.format("%d", val); end
        end
        table.insert(PocketGnome.output, string.format("|cffffeecc%s|r |cffaaeeaa=|r |cffaaaaff%s|r", text, val));
        local txt = "";
        for n = #PocketGnome.output, math.max(1,#PocketGnome.output-4), -1 do if ( PocketGnome.output[n] ) then txt = PocketGnome.output[n] .. "|n" .. txt; end end
        PocketGnome.result:SetText(txt);PocketGnome.edit:SetText("");
        PocketGnome.prevMath = text;
    else
        PocketGnome.mfuncs.answer = 0;
        if text:len() ~= 0 then print("PocketGnome: There is an error in your math formula, please check it."); end
    end
end
PocketGnome.window = CreateFrame("Frame", nil, UIParent);
PocketGnome.window:SetBackdrop({bgFile = "Interface\\PaperDollInfoFrame\\UI-GearManager-Title-Background",edgeFile = "Interface/GLUES/Common/TextPanel-Border",edgeSize = 16,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
PocketGnome.window:SetWidth(200)
PocketGnome.window:SetHeight(32);
PocketGnome.window:SetPoint("CENTER", UIParent, "CENTER", 0, -100);
PocketGnome.window:SetMovable(true);
PocketGnome.window:Hide();
PocketGnome.resultWindow = CreateFrame("Frame", nil, PocketGnome.window);
PocketGnome.resultWindow:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",edgeFile = "Interface/GLUES/Common/TextPanel-Border",edgeSize = 16,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
PocketGnome.resultWindow:SetBackdropColor(0,0,0,0.8);
PocketGnome.resultWindow:SetWidth(200)
PocketGnome.resultWindow:SetHeight(96);
PocketGnome.resultWindow:SetPoint("BOTTOMLEFT", PocketGnome.window, "TOPLEFT", 0, 0);
PocketGnome.resultWindow:RegisterForDrag("LeftButton");
PocketGnome.resultWindow:SetScript("OnDragStart",function()  PocketGnome.window:StartMoving(); end);
PocketGnome.resultWindow:SetScript("OnDragStop", function()  PocketGnome.window:StopMovingOrSizing(); end);
PocketGnome.resultWindow:EnableMouse(true);
local caption = PocketGnome.resultWindow:CreateFontString(nil, "DIALOG");
caption:SetFontObject(NumberFontNormal);
caption:SetPoint("TOPLEFT", PocketGnome.resultWindow, "TOPLEFT", 5, -5);
caption:SetPoint("BOTTOMRIGHT", PocketGnome.resultWindow, "BOTTOMRIGHT", -5, 5);
caption:SetJustifyH("RIGHT");
caption:SetJustifyV("BOTTOM");
PocketGnome.result = caption;
caption = PocketGnome.resultWindow:CreateFontString(nil, "DIALOG");
caption:SetFontObject(ChatFontNormal);
caption:SetPoint("TOPLEFT", PocketGnome.resultWindow, "TOPLEFT", 5, -4);
caption:SetPoint("BOTTOMRIGHT", PocketGnome.resultWindow, "BOTTOMRIGHT", -5, 5);
caption:SetJustifyV("TOP");
caption:SetText("PocketGnome");
CreateFrame("button", nil, PocketGnome.window, "UIPanelCloseButton"):SetPoint("TOPRIGHT", PocketGnome.window, "TOPRIGHT", 0, 0);
local editBox = CreateFrame("EditBox",nil, PocketGnome.window, "InputBoxTemplate");
editBox:SetAutoFocus(true);
editBox:SetScript("OnChar", function(me,key) if me:GetText():len() == 1 and me:GetText():match("^[%+%-%/%%%*]") then me:SetText("answer" .. key); end end);
editBox:SetScript("OnEscapePressed", function(me) if ( me:GetText():len() == 0 ) then PocketGnome.window:Hide(); end me:SetText(""); end);
editBox:SetScript("OnEnterPressed",  function(me) PocketGnome.Crunch(me:GetText()); end);
editBox:SetPoint("TOPLEFT", PocketGnome.window, "TOPLEFT", 25, -3);
editBox:SetPoint("BOTTOMRIGHT", PocketGnome.window, "BOTTOMRIGHT", -25, 3);
PocketGnome.edit = editBox;
_G.SLASH_POCKETGNOME1 = '/pocketgnome';
_G.SLASH_POCKETGNOME2 = '/pg';
SlashCmdList['POCKETGNOME'] = function() PocketGnome.window:Show() end;
